{==========================================================================}
{ Program            : MOSSIM                                              }
{ Author             : Robert Lacoste, Chaville, France                    }
{ Version            : 1.3                                                 }
{ Release date       : 27/07/1996                                          }
{==========================================================================}

{--------------------------------------------------------------------------}
{                              UNIT DEFSIGN                                }
{                                                                          }
{ Description : Definition and display of the signals levels               }
{                                                                          }
{--------------------------------------------------------------------------}

 UNIT DEFSIGN;

   INTERFACE                    {public declarations}
     USES GRAPH,
          CRT,
          DOS,
          DATA,
          GDS,
          PROCGEN,
          DESSINS,
          SIMUL;

     {put all signals to 0 level}
     PROCEDURE SIGNNULS;

     {mouse definition of the input levels}
     PROCEDURE SIGNAUX;

     {step by step levels watching}
     PROCEDURE PASAPAS;

   IMPLEMENTATION               {local declarations}

   {------------------------- put all signals to 0 level -----------------}

   PROCEDURE SIGNNULS;
     VAR I,J:INTEGER;
     BEGIN
       {clear outputs}
       SORTIESNULLES;

       {clear inputs}
       FOR I:=1 TO NBMENTREES DO
         FOR J:=1 TO LONGSIGN DO VALENTREES[I,J]:=0;

       {redraw signals}
       AFFICHESIGNAUX;
     END;

   {------------------------ mouse input of signals levels ---------------}

   PROCEDURE SIGNAUX;
     CONST MOUSE=51;            {mouse interrupt number}
     var finsig:boolean;
         r:registers;
         i:integer;
         xp,yp,ysign,ne,np:integer;
         SS:STRING;

        {subfunction : draw mouse cursor in reverse color}

        PROCEDURE CROIX;
          VAR XX,YY:INTEGER;
          BEGIN
            XX:=31+(NP-1)*ECARTHSIGN;
            YY:=NE*ECARTVSIGN+2+332;
            SETWRITEMODE(1); SETCOLOR(WHITE);
            MOVETO(XX-2,YY);
            LINETO(XX+8,YY);
            SETWRITEMODE(0);
          END;

   begin
     SS:='INPUT SIGNALS'; titre(SS); cr:=sacwk(fsignaux);
     SS:='R.click to quit'; info(ss,WHITE);

     {data initialisation}
     finsig:=false;
     NE:=1;NP:=1;

     {initialise active mouse aera}
     r.ax:=7; r.cx:=1; r.dx:=5*LONGSIGN-1; intr(MOUSE,r);
     r.ax:=8; r.cx:=1; r.dx:=5*NBMENTREES-1; intr(MOUSE,r);

     {main loop}
     repeat
       NE:=-1;

       {wait for mouses button release}
       REPEAT
         r.ax:=3; intr(MOUSE,r);
       UNTIL r.bx=0;

       {wait for mouse click}
       REPEAT
         {... while drawing mouse cursor}
         if (ne>=0) THEN CROIX;
         r.ax:=3; intr(MOUSE,r);
         delay(100);
         if (ne>=0) THEN CROIX;
         np:=r.cx DIV 5 +1; ne:=r.dx DIV 5+1;
       UNTIL (r.bx<>0);

       {if button 2 pressed, end of edit}
       if (r.bx>1) then finsig:=true
 	   else
         {if button 1, inverse current signal step}
         begin
           cr:=sacwk(fsignaux);
 	       xp:=26+(np-1)*ECARTHSIGN;
 		   yp:=6+ECARTVSIGN*ne;

           {erase current level}
 		   cr:=ssplci(0);
 		   ysign:=yp-2-valentrees[ne,np]*(ECARTVSIGN-4);
 		   cr:=sln(xp,ysign,xp+ECARTHSIGN,ysign);
           CR:=SLN(XP,YP-1,XP,YP-ECARTVSIGN+1);
           CR:=SLN(XP+ECARTHSIGN,YP-1,XP+ECARTHSIGN,YP-ECARTVSIGN+1);

           {inverse signal}
 		   valentrees[ne,np]:=1-valentrees[ne,np];

           {draw new signal level}
 		   cr:=ssplci(LIGHTCYAN);
 		   ysign:=yp-2-valentrees[ne,np]*(ECARTVSIGN-4);
 		   cr:=sln(xp,ysign,xp+ECARTHSIGN,ysign);

 		   if np<>1 then if valentrees[ne,np]<>valentrees[ne,np-1]
 		     then CR:=sln(xp,yp-2,xp,yp-ECARTVSIGN+2);

 		   if np<>LONGSIGN then if valentrees[ne,np]<>valentrees[ne,np+1]
             then CR:=sln(xp+ECARTHSIGN,yp-2,XP+ECARTHSIGN,yp-ECARTVSIGN+2);

         end;
     until finsig;

     {all nodes and outputs need to be recalculated}
     sortiesnulles;
     etatsnuls;
     affichesignaux;
   END;

   {------------------- step by step levels watching ----------------------}

   PROCEDURE PASAPAS;
     CONST MOUSE=51;            {mouse interrupt number}
     var finsig:boolean;
         r:registers;
         i:integer;
         xp,yp,ysign,ne,np:integer;
         SS:STRING;
         previousnp:integer;

        {subfunction : draw mouse cursor in reverse color}

        PROCEDURE CROIX(NP:INTEGER);
          VAR XX:INTEGER;
          BEGIN
            XX:=31+(NP-1)*ECARTHSIGN;
            SETWRITEMODE(1); SETCOLOR(WHITE);
            MOVETO(XX+3,340);
            LINETO(XX+3,472);
            SETWRITEMODE(0);
          END;

   begin
     SS:='WATCH STEP'; titre(SS); cr:=sacwk(fsignaux);

     {data initialisation}
     finsig:=false;
     NP:=1;
     previousnp:=0;

     {initialise active mouse aera}
     r.ax:=7; r.cx:=1; r.dx:=5*LONGSIGN-1; intr(MOUSE,r);
     r.ax:=8; r.cx:=1; r.dx:=5*NBMENTREES-1; intr(MOUSE,r);

     {define current mouse position}
     r.ax:=4; r.cx:=1; r.dx:=1; intr(MOUSE,r);

     {main loop}
     repeat
       cr:=sacwk(fsignaux);

       {get mouse position}
       r.ax:=3; intr(MOUSE,r);
       np:=r.cx DIV 5 +1;

       {if button 2 pressed, end of view}
       if (r.bx>1) then finsig:=true
 	   else
         if (np <> previousnp) then
           begin
             if (previousnp <>0) then CROIX(previousnp);
             CROIX(np);
             previousnp:=np;

             {calculate simulation states up to state number "np"}
             SIMULATION(np);
             SS:='R.click to quit'; info(SS,WHITE);

             {draw signals level}
             CROIX(previousnp);
             AFFICHESIGNAUX;
             CROIX(previousnp);

             {draw signals levels at current step on network view}
             DESSINNIVEAUX (TRUE, NOEUDS);

           end;
     until finsig;
     if (previousnp <> 0) then CROIX(previousnp);
     dessinniveaux (false, noeuds);
   END;

 {--------------------------- Unit initialisation -------------------------}

 BEGIN
 END.

{==========================================================================}
{                              END OF FILE                                 }
{==========================================================================}




