{==========================================================================}
{ Program            : MOSSIM                                              }
{ Author             : Robert Lacoste, Chaville, France                    }
{ Version            : 1.3                                                 }
{ Release date       : 27/07/1996                                          }
{                                                                          }
{ Copyright notice   : This software can be freely copied, distributed     }
{                      and used under the following conditions :           }
{                                                                          }
{  1/ Inclusion of this copyright notice                                   }
{  2/ Inclusion of the Author's name in documentation and executable       }
{  3/ Systematic delivery of all the source code, examples                 }
{     and documentation files                                              }
{  4/ All right on this software remains exclusively                       }
{     property of the author                                               }
{  5/ As everything free, this software is released without any warranty   }
{  6/ Every modification of the source files have to be documented in      }
{     the "history" section of this file, and the version number of        }
{     the program have to be increased (both in comments and on screen).   }
{                                                                          }
{ History and release changes :                                            }
{  1.0 : first version, developped on a Bull SPS7 Unix workstation as      }
{        part of a student project                                         }
{  1.1 : recompilation on an... Apple II computer, under UCSD Pascal       }
{  1.2 : recompilation for PC compatible computer under Turbo Pascal,      }
{        simulation optimization, many graphical improvements              }
{  1.3 : this version, cosmetic improvements for Elektor contest           }
{                                                                          }
{ Compiler           : Borland turbo pascal 5.5 or compatible              }
{ Requirements       : PC compatible, MSDOS 5.0, microsoft compat. mouse,  }
{                      VGA color screen                                    }
{                                                                          }
{==========================================================================}

{--------------------------------------------------------------------------}
{                              MAIN PROGRAM                                }
{--------------------------------------------------------------------------}


 program mossim(input,output);

 {------------------------ Global declarations ----------------------------}

 USES GRAPH,             { units loading }
      CRT,
      DATA,
      GDS,
      PROCGEN,
      DESSINS,
      DEFSIGN,
      AJOUTS,
      CONNECT,
      CORRECT,
      FICH,
      SIMUL;

 VAR S,SS:STRING;        { temporary }
     NFEN:INTEGER;       { selected menu option }
     BIENVENUE:BOOLEAN;  { true if welcome message is displayed }
     CH:CHAR;            { temporary }

 {------------------------ Menu presentation ------------------------------}

 PROCEDURE OPTIONS;
  VAR S:STRING;
      I,C:INTEGER;
  BEGIN

   { data initialisations }
   NFEN:=0;
   initialisations;
   FOR I:=1 TO NBMENTREES DO FOR J:=1 TO LONGSIGN DO VALENTREES[I,J]:=0;

   { grid drawing }
   affichegrille;

   { menu options drawing }
   cr:=sacwk(ftexte);
   c:=LIGHTRED;
   cr:=ssfaci(4);
     I:=10;
     S:='@/Global reset'; CR:=STX(8,I,C,S); I:=I+26;
     S:='S/Left  transi.'; CR:=STX(8,I,C,S); I:=I+13;
     S:='D/Right transi.'; CR:=STX(8,I,C,S); I:=I+13;
     S:='E/Up    transi.'; CR:=STX(8,I,C,S); I:=I+13;
     S:='X/Down  transi.'; CR:=STX(8,I,C,S); I:=I+13;
     S:='P/Pullup'; CR:=STX(8,I,C,S); I:=I+13;
     S:='+/Vcc   '; CR:=STX(8,I,C,S); I:=I+13;
     S:='-/Vss   '; CR:=STX(8,I,C,S); I:=I+13;
     S:='</Input'; CR:=STX(8,I,C,S); I:=I+13;
     S:='>/Output'; CR:=STX(8,I,C,S); I:=I+13;
     S:='T/Text';CR:=STX(8,I,C,S); I:=I+26;
     S:='C/Connections'; CR:=STX(8,I,C,S); I:=I+26;
     S:='K/Correction'; CR:=STX(8,I,C,S); I:=I+26;
     S:='L/Levels '; CR:=STX(8,I,C,S); I:=I+13;
     S:='O/Signals reset'; CR:=STX(8,I,C,S); I:=I+13;
     S:='G/Go simulation'; CR:=STX(8,I,C,S); I:=I+13;
     S:='W/Watch step'; CR:=STX(8,I,C,S); I:=I+13;
     S:='V/Load'; CR:=STX(8,I,C,S); I:=I+13;
     S:='B/Save'; CR:=STX(8,I,C,S); I:=I+13;
     S:='Q/Quit'; CR:=STX(8,I,C,S); I:=I+13;
 end;

 {--------------------------- global reset --------------------------------}

 procedure nouveaufichier;
   VAR B:BOOLEAN; SZZ:STRING;
   begin
     s:='GLOBAL RESET'; TITRE(s);

     { confirmation needed ? }
     IF MODIFIE THEN B:=CONFIRME ELSE B:=TRUE;

     { if so, reset }
     IF B THEN BEGIN
                 SZZ:='Working...';info(SZZ,WHITE);
                 INITIALISATIONS;
                 AFFICHEGRILLE;
               END;
   end;

 {------------------- Menu option graphical inversion ---------------------}

 PROCEDURE INVERSE (N:INTEGER);
   BEGIN
     NFEN:=N;
     SETWRITEMODE(1); SETCOLOR(WHITE);
     RECTANGLE(503,N*13-6,636,N*13+11-4);
     SETWRITEMODE(0);
     CR:=SACWK(FTEXTE);
   END;

 {---------------------- Menu option selection ----------------------------}

 PROCEDURE MENU;
    BEGIN
     { statistics display }
     STATISTICS;

     {clear title zone}
     S:='MENU'; titre(s);
     S:='Select option'; info(s,WHITE);

     { restore selected option in normal video mode }
     IF NFEN<>0 THEN INVERSE(NFEN);
     NFEN:=0;

     { get user choice and select fonction }
     ch:=READKEY;

     {if welcome message is displayed, clear it}
     if bienvenue then
       begin
         bienvenue:=false;
         cr:=sacwk(fschema);
         cr:=ssfaci(BLACK); cr:=sgr(105,125,395,225);
         affichegrille;
       end;

     case ch of
 	   '@'    : BEGIN INVERSE(1); NOUVEAUFICHIER; SIGNNULS;END;
       's','S': BEGIN INVERSE(3); FAITTRANSISTOR(2);END;
       'd','D': BEGIN INVERSE(4); FAITTRANSISTOR(1);END;
       'e','E': BEGIN INVERSE(5); FAITTRANSISTOR(3);END;
       'x','X': BEGIN INVERSE(6); FAITTRANSISTOR(4);END;
       'p','P': BEGIN INVERSE(7); FAITPULLUP;END;
       '+'    : BEGIN INVERSE(8); FAITALIM(1);END;
       '-'    : BEGIN INVERSE(9); FAITALIM(2);END;
       '<'    : BEGIN INVERSE(10); FAITENTREE;END;
       '>'    : BEGIN INVERSE(11); FAITSORTIE;END;
       't','T': BEGIN INVERSE(12); FAITTXT; END;
       'c','C': BEGIN INVERSE(14); CONNECTE;END;
       'k','K': BEGIN INVERSE(16); CORRECTION;END;
       'l','L': BEGIN INVERSE(18); SIGNAUX; END;
       'o','O': BEGIN INVERSE(19); s:='SIGNALS RESET';titre(s);
                                   if confirme then SIGNNULS; END;
       'g','G': BEGIN INVERSE(20); s:='SIMUL'; TITRE(s);
                                   SIMULATION(LONGSIGN);AFFICHESIGNAUX;
                                   sortiescalculees:=true; END;
       'w','W': BEGIN INVERSE(21); PASAPAS; sortiescalculees:=true; END;
       'v','V': BEGIN INVERSE(22); CHARGEMENT;SORTIESNULLES;
                                   AFFICHESIGNAUX;END;
       'b','B': BEGIN INVERSE(23); SAUVEGARDE;END;
       'q','Q': BEGIN INVERSE(24); fini:=true; S:='QUIT'; TITRE(s);
                      if modifie then if not(confirme) then fini:=false;
                END;
     end;
   END;

 {-------------------------- Main program --------------------------------}

 begin
   {check if mouse driver available}
   if not sourispresente
   then
     begin
       writeln ('No mouse driver available. Please load mouse.com');
       halt;
     end;

   {windows opening}
   ouvrefenetres;

   {heap pointer initialisation}
   mark(mainheapmark);

   { initialisations }
   OPTIONS;
   fini:=false;
   SIGNNULS;

   {display welcome message}
   bienvenue:=true;
   cr:=sacwk(fschema);
   cr:=ssfaci(BLUE); cr:=sgr(105,105,395,225);
   cr:=ssplci(YELLOW);
   cr:=sln(105,105,395,105); cr:=sln(105,225,395,225);
   cr:=sln(105,105,105,225); cr:=sln(395,105,395,225);
   cr:=stx(180,140,YELLOW,'WELCOME TO MOSSIM');
   cr:=stx(120,180,YELLOW,'THE MAGICAL DYNAMIC MOS SIMULATOR');

   { main loop }
   repeat
     MENU
   until fini;

   { windows closing }
   fermefenetres;
 end.

{==========================================================================}
{                              END OF FILE                                 }
{==========================================================================}




